; Super NESquik Demo
; (c) 30/5/93 Andy The Arfling Productions

	int	all=nowt
	int	nmi=vblank
	int	res=start

; H/W Shadows 
scroll1x	equ	$200		; Word
scroll1y	equ	$202		; Word
scroll2x	equ	$204		; Word
scroll2y	equ	$206		; Word
dma0f	equ	$208		; Byte - DMA 0 flag
dma0s	equ	$209		; Word - DMA 0 source (lo,hi)
dma0b	equ	$20b		; Byte - DMA 0 source (bank)
dma0d	equ	$20c		; Word - DMA 0 size
scrnfade	equ	$20e		; Byte
hdma_on	equ	$20f
spr_table	equ	$210		; Table of (x,y,char) * 128 + Extra

; Global Variables
vbl_done	equ	$1000		; Byte

; Scroller Variables
message	equ	$2		; Word
horpos	equ	$1002		; Word
mespos	equ	$1004		; Word
chrptr	equ	$1006		; Word
char_size	equ	$1008		; Byte
bnce_ptr equ	$1009		; Word  - Not used together!
hdma_ptr	equ	$1009		; Word  -         " 
star_dir	equ	$100b		; Byte
scrl_table equ	$100c		; 64 Words

; Mode 7 Variables
the_endy	equ	$c0		; Y position of "The End"
matrix_ptr equ	$1002
matrix_size equ	$1004
bounce_ptr equ	$1006		; Not used together!
sine_ptr	equ	$1006		;         "
mode7_time equ	$1008
mode7_type equ	$1009
copper	equ	$100a

; Sprite Variables
spr_delay	equ	10		; Number of frames between letters
spr_ptrx	equ	$1002
spr_ptry	equ	$1004
spr_time	equ	$1006
chess_x	equ	$1008
chess_y	equ	$100a
chess_z	equ	$100c

; Ring Variables
bg_ptrx	equ	$1002
bg_ptry	equ	$1004
ring_time	equ	$1006
logo_x	equ	$1007
logo_y	equ	$1009
logo_dir	equ	$100a
logo_del	equ	$100b

; Bar Variables
text_delay	equ	250	; Number of frames for pause
text_del	equ	$100a
text_flag	equ	$100c
bar_type	equ	$100e
bar_pos	equ	$1010
bar_pos1	equ	$1011
bar_pos2	equ 	$1013
bar_tab	equ	$1015
bar_table	equ	$7e0000


; Code

start
	jsr	init_all		; Init Demo
 	jsr	music_init	; Init Music

	jsr	reset_all		; Init walking logo
	jsr	mode7_init1
	jsr	ints_on

wait1	lda	vbl_done		; Walking logo
	beq	wait1
	stz	vbl_done
	jsr	bounce_logo
	jsr	spin_logo
	ldx	matrix_ptr
	bne	wait1

	jsr	ints_off		; Init scroller
	jsr	reset_all
	ldx	#message1
	stx	message
	jsr	scroller_init
	lda	#3
	sta	star_dir
	jsr	stars_init
	jsr	ints_on

wait2	lda	vbl_done		; Scroller
	beq	wait2
	stz	vbl_done
	jsr	stars
	jsr	scroller
	ldx	mespos
	bne	wait2

.1	lda	vbl_done
.2	cmp	vbl_done		; Fade out scroller
	beq	.2
	jsr	stars
	jsr	scroller
	lda	vbl_done
	cmp	#4
	bne	.1
	stz	vbl_done
	dec	scrnfade
	bne	.1

	jsr	ints_off		; Init sprites
	jsr	reset_all
	jsr	sprites_init
	jsr	chess
	jsr	sprites
	lda	#4
	sta	spr_time
	jsr	ints_on
	lda	#0
	sta	vbl_done

wait3	cmp	vbl_done		; Sprites
	beq	wait3
	jsr	chess
	jsr	sprites
	lda	vbl_done
	bne	wait3
	dec	spr_time
	bne	wait3

	jsr	ints_off		; Init waveylogo
	jsr	reset_all
	jsr	dots_init
	jsr	mode7_init2
	jsr	ints_on
	stz	vbl_done

wait4	lda	vbl_done		; Wavey logo
	beq	wait4
	stz	vbl_done
	jsr	move_dots
	jsr	sink_logo
	jsr	wavey_logo
	lda	mode7_type
	cmp	#5
	bne	wait4

	jsr	ints_off		; Init bouncing scroller
	jsr	reset_all
	ldx	#message2
	stx	message
	stz	bnce_ptr
	stz	bnce_ptr+1
	jsr	scroller_init
	lda	#3
	sta	star_dir
	jsr	stars_init
	jsr	ints_on

wait5	lda	vbl_done		; Scroller
	beq	wait5
	stz	vbl_done
	jsr	stars
	jsr	scroller
	jsr	scroller_bounce
	ldx	mespos
	bne	wait5

fade2	lda	vbl_done
fade2w	cmp	vbl_done		; Fade out scroller
	beq	fade2w
	jsr	stars
	jsr	scroller
	jsr	scroller_bounce
	lda	vbl_done
	cmp	#4
	bne	fade2
	stz	vbl_done
	dec	scrnfade
	bne	fade2

	jsr	ints_off		; Init rings
	jsr	reset_all
	jsr	rings_init
	lda	#6
	sta	ring_time
	jsr	ints_on
	lda	#0
	sta	vbl_done

wait6	cmp	vbl_done		; Rings
	beq	wait6
	jsr	rings
	jsr	ring_logo
	lda	vbl_done
	bne	wait6
	dec	ring_time
	bne	wait6

	jsr	ints_off		; Init HDMA scroller
	jsr	reset_all
	ldx	#message3
	stx	message
	jsr	scroller_init
	jsr	scroller_hdma_init
	lda	#3
	sta	star_dir
	jsr	stars_init
	jsr	ints_on

wait7	lda	vbl_done		;  HDMA Scroller
	beq	wait7
	stz	vbl_done
	jsr	stars
	jsr	scroller
	jsr	scroller_hdma
	ldx	mespos
	bne	wait7

fade3	lda	vbl_done
fade3w	cmp	vbl_done		; Fade out scroller
	beq	fade3w
	jsr	stars
	jsr	scroller
	jsr	scroller_hdma
	lda	vbl_done
	cmp	#4
	bne	fade3
	stz	vbl_done
	dec	scrnfade
	bne	fade3

	jsr	ints_off		; Init colour bars
	jsr	reset_all
	jsr	init_bars1
	jsr	bar_loop
	jsr	init_bars2
	jsr	bar_loop
	jsr	init_bars3
	jsr	bar_loop
	jsr	init_bars4
	jsr	bar_loop

	jsr	ints_off		; Init spinning logo
	jsr	reset_all
	jsr	mode7_init3
	jsr	music_init2
	jsr	ints_on

wait8	lda	vbl_done		; Spinning logo
	beq	wait8
	stz	vbl_done
	jsr	spin_logo
	bra	wait8


**************************************
; Interrupts

vblank
	rep	#$30
	pha
	phx
	phy

	jsr	copy_shadows

	inc	vbl_done

	rep	#$30
	ply
	plx
	pla
	rti

nowt
	rti


*******************************************************
; Copy shadow reggies to h/w reggies
copy_shadows
	sep	#$20
	rep	#$10

	lda	#$8f
	sta	$2100

	lda	scroll1x		; Scroll reggies
	sta	$210d
	lda	scroll1x+1
	sta	$210d
	lda	scroll1y
	sta	$210e
	lda	scroll1y+1
	sta	$210e
	lda	scroll2x
	sta	$210f
	lda	scroll2x+1
	sta	$210f
	lda	scroll2y
	sta	$2110
	lda	scroll2y+1
	sta	$2110

	stz	$4300		; DMA #0 for sprite table -> OAM
	stz	$2102
	stz	$2103
	lda	#4
	sta	$4301
	ldx	#spr_table
	stx	$4302
	stz	$4304
	ldx.l	#272*2
	stx	$4305

	lda	dma0f		; DMA #1 -> VRAM (if needed)
	beq	no_dma0
	stz	dma0f
	lda	#$80
	sta	$2115
	ldx	dma0d
	stx	$2116
	ldx.l	#$1801
	stx	$4310
	ldx	dma0s
	stx	$4312
	lda	dma0b
	sta	$4314
	ldx.l	#$01c0
	stx	$4315
	lda	#3
	bra	dma_done
no_dma0 	lda	#1
dma_done	sta	$420b

	lda	scrnfade
	sta	$2100	
	lda	hdma_on
	sta	$420c
	rts

*******************************************************
; Scoller code

scroller
	sep	#$20
	rep	#$10

	ldx	horpos		; Do actual scrolling
	inx
	inx
	inx
	inx
	stx	horpos
	stx	scroll1x

	dec	char_size		; Need another letter?
	bne	.all_done

	lda	#4		; 16 / 4 = 4 frames b4 next char
	sta	char_size
	ldy	mespos		; Read message
	iny
	lda	(message),y
	bpl	.no_wrap
	ldy	#message0
	sty	message
	ldy.l	#0		; Wrap time
	lda	(message)
.no_wrap	sty	mespos

	cmp	#64
	bcc	.bank1
	sec
	sbc	#64
	pha
	lda	#scroller_font>>16+1
	bra	.bank2
.bank1	pha
	lda	#scroller_font>>16
.bank2	sta	dma0b
	pla

	sta	$4202		; Multiply accumulator by $1c0
	lda	#7
	sta	$4203
	nop
	nop
	nop
	nop
	ldx	$4216
	rep	#$20
	txa
	clc
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a

	adc.l	#$8000		; Add on bank start
	tax

	sep	#$20

	lda	#1		; Blit on 1 new char
	sta	dma0f
	stx	dma0s
	ldx	chrptr
	stx	dma0d

	rep	#$20	
	lda	chrptr
	clc
	adc.l	#$00e0
	cmp.l	#$2c10
	bne	.alright
	lda.l	#$1010
.alright	sta	chrptr

.all_done
	sep	#$20
	rts			; All done

; Scroller bounce code
scroller_bounce
	ldx	bnce_ptr
	inx
	inx
	cpx.l	#scroll_bounce_end-scroll_bounce
	bne	.ok
	ldx.l	#0
.ok	stx	bnce_ptr
	rep	#$20
	lda	scroll_bounce,x
	sta	scroll1y
	sep	#$20
	rts

; Scroller HDMA code
scroller_hdma
	rep	#$20
	ldx	hdma_ptr
	inx
	inx
	cpx.l	#scroll_sine_end-scroll_sine
	bne	.ok
	ldx.l	#0
.ok	stx	hdma_ptr
	ldy.l	#0
.1	lda	scroll1x
	clc
	adc	scroll_sine,x
	sta	scrl_table,y
	inx
	inx
	iny
	iny
	cpy.l	#64*2
	bne	.1
	sep	#$20
	rts
	
*******************************************************
; Star code
; Oh for macros, it would have made the next bit a quarter of the size!
stars
	sep	#$10
	lda	star_dir
	asl
	tax
	jmp	(.star_tab,x)

.star_tab
	dcw	.dir1&$ffff
	dcw	.dir2&$ffff
	dcw	.dir3&$ffff
	dcw	.dir4&$ffff

.dir1
	rep	#$10
	ldx.l	#spr_table+32*4
	lda	#32
.11	inc	0,x
	inc	0,x
	inc	0,x
	dec	1,x
	dec	1,x
	dec	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.11
	lda	#32
.12	inc	0,x
	inc	0,x
	dec	1,x
	dec	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.12
	lda	#32
.13	inc	0,x
	dec	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.13
	rts
.dir2
	rep	#$10
	ldx.l	#spr_table+32*4
	lda	#32
.21	dec	0,x
	dec	0,x
	dec	0,x
	dec	1,x
	dec	1,x
	dec	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.21
	lda	#32
.22	dec	0,x
	dec	0,x
	dec	1,x
	dec	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.22
	lda	#32
.23	dec	0,x
	dec	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.23
	rts
.dir3
	rep	#$10
	ldx.l	#spr_table+32*4
	lda	#32
.31	inc	0,x
	inc	0,x
	inc	0,x
	inc	1,x
	inc	1,x
	inc	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.31
	lda	#32
.32	inc	0,x
	inc	0,x
	inc	1,x
	inc	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.32
	lda	#32
.33	inc	0,x
	inc	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.33
	rts
.dir4
	rep	#$10
	ldx.l	#spr_table+32*4
	lda	#32
.41	dec	0,x
	dec	0,x
	dec	0,x
	inc	1,x
	inc	1,x
	inc	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.41
	lda	#32
.42	dec	0,x
	dec	0,x
	inc	1,x
	inc	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.42
	lda	#32
.43	dec	0,x
	inc	1,x
	inx
	inx
	inx
	inx
	dec
	bne	.43
	rts

*******************************************************
; Dot code
move_dots
	ldx.l	#spr_table+64*4
	lda	#16
.1	dec	0,x
	dec	0,x
	dec	0,x
	dec	0,x
	inx
	inx
	inx
	inx
	dec
	bne	.1
	lda	#16
.2	dec	0,x
	dec	0,x
	dec	0,x
	inx
	inx
	inx
	inx
	dec
	bne	.2
	lda	#16
.3	dec	0,x
	dec	0,x
	inx
	inx
	inx
	inx
	dec
	bne	.3
	lda	#16
.4	dec	0,x
	inx
	inx
	inx
	inx
	dec
	bne	.4
	rts

*******************************************************
; Mode 7 stuff
; Do bounce
bounce_logo
	ldx	bounce_ptr
	lda	$0,x
	bpl	.ok
	ldx.l	#bounce_data
	lda	$0,x
.ok	sta	$210e
	stz	$210e
	inx
	stx	bounce_ptr
	rts

; Set up mode 7 matrix
spin_logo
	ldy	matrix_ptr
	lda	[message],y
	sta	$211b	
	iny
	lda	[message],y
	sta	$211b
	iny	
	lda	[message],y
	sta	$211c
	iny	
	lda	[message],y
	sta	$211c
	iny	
	lda	[message],y
	sta	$211d	
	iny
	lda	[message],y
	sta	$211d
	iny	
	lda	[message],y
	sta	$211e
	iny	
	lda	[message],y
	sta	$211e
	iny	
	cpy	matrix_size
	bne	.ok
	ldy.l	#0
.ok	sty	matrix_ptr
	rts

; Watery logo
sink_logo
	sep	#$10
	lda	mode7_type
	asl
	tax
	jmp	(.vbl,x)
.vbl
	dcw	.type0&$ffff
	dcw	.type1&$ffff
	dcw	.type2&$ffff
	dcw	.type3&$ffff
	dcw	.type4&$ffff
	dcw	.done&$ffff

.type0 ; Wait while it's in the stars
	dec	mode7_time
	bne	.done
	inc	mode7_type
	lda	#200
	sta	mode7_time
	bra	.done
.type1 ; Move it down
	rep	#$10
	dec	mode7_time
	lda	mode7_time
	lsr
	sta	scroll1y
	bne	.done
	inc	mode7_type
	lda	#250
	sta	mode7_time
	bra	.done
.type2 ; Wait while it's in the water
	dec	mode7_time
	bne	.done
	inc	mode7_type
	bra	.done
.type3 ; Move it up
	inc	mode7_time
	lda	mode7_time
	lsr
	sta	scroll1y
	cmp	#100
	bne	.done
	inc	mode7_type
	lda	#200
	sta	mode7_time
	bra	.done
.type4 ; Wait while it's in the stars
	dec	mode7_time
	bne	.done
	inc	mode7_type
.done	rep	#$10
	rts

********************************************************
; Sprite code
sprites
	ldx	spr_ptrx
	inx
	cpx.l	#ssinex_end-ssinex
	bne	.okx
	ldx.l	#0
.okx	stx	spr_ptrx
	lda	ssinex_end,x		; N
	sta	spr_table
	lda	ssinex_end-spr_delay,x	; E
	sta	spr_table+4
	lda	ssinex_end-spr_delay*2,x	; S
	sta	spr_table+8
	lda	ssinex_end-spr_delay*3,x	; Q
	sta	spr_table+12
	lda	ssinex_end-spr_delay*4,x	; U
	sta	spr_table+16
	lda	ssinex_end-spr_delay*5,x	; I
	sta	spr_table+20
	lda	ssinex_end+1-spr_delay*6,x	; K
	sta	spr_table+24

	ldx	spr_ptry
	inx
	cpx.l	#ssiney_end-ssiney
	bne	.oky
	ldx.l	#0
.oky	stx	spr_ptry
	lda	ssiney_end,x		; N
	sta	spr_table+1
	lda	ssiney_end-spr_delay,x	; E
	sta	spr_table+5
	lda	ssiney_end-spr_delay*2,x	; S
	sta	spr_table+9
	lda	ssiney_end-spr_delay*3,x	; Q
	sta	spr_table+13
	lda	ssiney_end-spr_delay*4,x	; U
	sta	spr_table+17
	lda	ssiney_end-spr_delay*5,x	; I
	sta	spr_table+21
	lda	ssiney_end+1-spr_delay*6,x	; K
	sta	spr_table+25
	rts

********************************************************
; Chess board
chess
	rep	#$20		; Set X centre
	lda	scroll1x
	clc
	adc.l	#128
	sep	#$20
	sta	$211f
	xba
	sta	$211f

	rep	#$20		; Set Y centre
	lda	scroll1y
	clc
	adc.l	#112
	sep	#$20
	sta	$2120
	xba
	sta	$2120

	rep	#$20		; Scroll X
	ldx	chess_x
	inx
	inx
	cpx	#chess_sinex_end-chess_sinex
	bne	.ok1
	ldx.l	#0
.ok1	stx	chess_x
	lda	chess_sinex,x
	sta	scroll1x

	ldx	chess_y		; Scroll Y
	inx
	inx
	cpx	#chess_siney_end-chess_siney
	bne	.ok2
	ldx.l	#0
.ok2	stx	chess_y
	lda	chess_siney,x
	sta	scroll1y

	sep	#$20		; Scroll Z
	ldx	chess_z
	inx
	inx
	cpx	#chess_sinez_end-chess_sinez
	bne	.ok3
	ldx.l	#0
.ok3	stx	chess_z
	lda	chess_sinez,x
	sta	$211b
	lda	chess_sinez+1,x
	sta	$211b
	lda	chess_sinez,x
	sta	$211e
	lda	chess_sinez+1,x
	sta	$211e
	rts

********************************************************
; Wavey logo code
wavey_logo
	ldx.l	#4
	ldy	sine_ptr
	iny
	iny
	cpy.l	#wsine_end-wsine
	bne	.ok
	ldy.l	#0
.ok	sty	sine_ptr
	lda	#80
.loop	pha
	rep	#$20
	lda	wsine,y
	sta	copper,x
	iny
	iny
	inx
	inx
	inx
	sep	#$20
	pla
	dec	a
	bne	.loop
	rts


********************************************************
; Ring code
rings
	ldx	bg_ptrx
	inx
	cpx.l	#sinex_end-sinex
	bne	.okx
	ldx.l	#0
.okx	stx	bg_ptrx
	lda	sinex_end,x
	sta	scroll1x
	lda	sinex_end-22,x
	sta	scroll2x

	ldx	bg_ptry
	inx
	cpx.l	#siney_end-siney
	bne	.oky
	ldx.l	#0
.oky	stx	bg_ptry
	lda	siney_end,x
	sta	scroll1y
	lda	siney_end-16,x
	sta	scroll2y
	rts

ring_logo
	dec	logo_del		; Move it down
	bne	.same_y
	lda	#3
	sta	logo_del
	inc	logo_y

.same_y	ldx	logo_x		; Move it across
	lda	logo_dir
	bmi	.left
	inx
	cpx	#$100
	bne	.ok
	lda	#4
	sta	logo_y
	lda	#$ff
	bra	.ok
.left	dex
	cpx	#$ff00
	bne	.ok
	lda	#$10
	sta	logo_y
	lda	#1
.ok	sta	logo_dir
	stx	logo_x

	jsr	add_logo
	rts


********************************************************
; Bar Code
bar_loop
	stz	text_flag
	stz	scrnfade
	stz	vbl_done
	jsr	ints_on

.wait1	lda	vbl_done
.1	cmp	vbl_done
	beq	.1
	jsr	bars
	lda	vbl_done
	cmp	#8
	bne	.wait1
	stz	vbl_done
	lda	scrnfade
	inc
	cmp	#16
	beq	.wait2
	sta	scrnfade
	bra	.wait1

.wait2	lda	vbl_done
.2	cmp	vbl_done
	beq	.2
	stz	vbl_done
	jsr	bars
	jsr	bar_text
	lda	text_del
	cmp	#text_delay
	bne	.wait2
	lda	text_flag
	bne	.wait3
	inc	text_flag
	bra	.wait2

.wait3	lda	vbl_done
.3	cmp	vbl_done
	beq	.3
	jsr	bars
	lda	vbl_done
	cmp	#8
	bne	.wait3
	stz	vbl_done
	dec	scrnfade
	bne	.wait3	

	jsr	ints_off
	rts

; Bar VBL code
bars
	ldx.l	#0
	ldy.l	#234
	rep	#$20
.1	lda	bar_table,x
	sta	bar_tab,x
	inx
	inx
	dey
	bne	.1
	sep	#$20
	lda	bar_tab+1
	sta	$2110
	ldx	bar_type
	jmp	(bar_ptrs,x)

bar_ptrs
	dcw	bars_straight&$ffff
	dcw	bars_diagonal&$ffff
	dcw	bars_sine&$ffff
	dcw	bars_wavey&$ffff

bar_text
	lda	text_del
	bne	.del
	ldx	scroll1y
	inx
	stx	scroll1y
	cpx.l	#14*16
	beq	.stop
	cpx.l	#28*16
	bne	.done
.stop	lda	#text_delay+1
.del	dec
	sta	text_del
.done	rts


bars_straight
	lda	bar_pos
	inc
	and	#63
	sta	bar_pos
	ldx.l	#0
	ldy.l	#234
.1	sta	bar_table,x
	inx
	dec
	dey
	bne	.1
	rts

; Scroll diagonal bars across
bars_diagonal
	lda	bar_pos
	inc
	and	#63
	sta	bar_pos
	ldx.l	#0
	ldy.l	#117
.1	sta	bar_table,x
	inx
	dey
	bne	.1
	ldy.l	#117
.2	sta	bar_table,x
	inx
	dec
	dec
	dey
	bne	.2
	rts

; Scroll sine bars across
bars_sine
	lda	bar_pos
	inc
	and	#63
	sta	bar_pos
	xba
	lda	#234
	ldx.l	#0
	ldy.l	#0
.1	xba
	pha
	lda	bar_sine,y
	lsr
	clc
	adc	1,s
	sta	bar_table,x
	pla
	inx
	iny
	iny
	dec
	cpy.l	#bar_sine_end-bar_sine
	bne	.2
	ldy.l	#0
.2	xba
	dec
	bne	.1
	rts

; Scroll wavey bars across
bars_wavey
	lda	bar_pos
	inc
	and	#63
	sta	bar_pos
	xba
	lda	#234
	ldy	bar_pos1
	iny
	cpy.l	#bar_sine_end-bar_sine
	bne	.ok1
	ldy.l	#0
.ok1	sty	bar_pos1
	ldx.l	#0
.1	xba
	pha
	clc
	adc	bar_sine,y
	sta	bar_table,x
	pla
	inx
	iny
	dec
	cpy.l	#bar_sine_end-bar_sine
	bne	.2
	ldy.l	#0
.2	xba
	dec
	bne	.1
	ldy	bar_pos2
	iny
	iny
	cpy.l	#bar_sine_end-bar_sine
	bne	.ok2
	ldy.l	#0
.ok2	sty	bar_pos2
	ldx.l	#0
	lda	#234
.3	xba
	lda	bar_sine,y
	clc
	adc	bar_table,x
	sta	bar_table,x
	iny
	inx
	cpy.l	#bar_sine_end-bar_sine
	bne	.4
	ldy.l	#0
.4	xba
	dec
	bne	.3	
	rts

********************************************************

init_all ; Main init routine for whole demo, call this only wonce
	clc			; Into native mode
	xce
	sei			; disable irq's
	rep	#$10		; set X+Y to 16 bit
	sep	#$20		; and set accum to 8 bit
	ply			; return address
	ldx.l	#$01ff		; and set up the stack
	txs			; to top of lo-ram
	phy			; back on stack
	lda	#$00		; clear the top byte of the accum
	xba			; by swapping it up
	lda	#$00
	pha
	plb			; set the data bank register to 0
	lda	#0		; set direct register to zero
	tcd
	rts


reset_all	; Restores all h/w reggies to recommended init vals (page 1.26.1)
 	lda	#$8f
 	sta	$2100
 	stz	$2101
 	stz	$2102
 	stz	$2103
 	jsr	reset_oram
 	stz	$2105
 	stz	$2106
 	stz	$2107
 	stz	$2108
 	stz	$2109
 	stz	$210a
 	stz	$210b
 	stz	$210c
 	stz	$210d
 	stz	$210d
 	stz	$210e
 	stz	$210e
 	stz	$210f
 	stz	$210f
 	stz	$2110
 	stz	$2110
 	stz	$2111
 	stz	$2111
 	stz	$2112
 	stz	$2112
 	stz	$2113
 	stz	$2113
 	stz	$2114
 	stz	$2114
 	lda	#$80
 	sta	$2115
 	stz	$2116
 	stz	$2117
 	jsr	reset_vram
 	stz	$211a
 	lda	#1
 	stz	$211b
 	sta	$211b
 	stz	$211c
 	stz	$211c
 	stz	$211d
 	stz	$211d
 	stz	$211e
 	sta	$211e
 	stz	$211f
 	stz	$211f
 	stz	$2120
 	stz	$2120
 	stz	$2121
 	jsr	reset_cram
 	stz	$2123
 	stz	$2124
 	stz	$2125
 	stz	$2126
 	stz	$2127
 	stz	$2128
 	stz	$2129
 	stz	$212a
 	stz	$212b
 	stz	$212c
 	stz	$212d
 	stz	$212e
 	lda	#$30
 	sta	$2130
 	stz	$2131
 	lda	#$e0
 	sta	$2132
 	stz	$2133
 	stz	$4200
 	lda	#$ff
 	sta	$4201
 	stz	$4202
 	stz	$4203
 	stz	$4204
 	stz	$4205
 	stz	$4206
 	stz	$4207
 	stz	$4208
 	stz	$4209
 	stz	$420a
 	stz	$420b
 	stz	$420c
 	stz	$420d

	ldx.l	#0
	stx	$200
	stx	$202
	stx	$204
	stx	$206
	stx	$208
	stx	$20a
	stx	$20c
	stx	$20e
	rts
	
reset_oram			; Clear ORAM
	stz	scroll1x
	stz	scroll1x+1
	lda	#%1000		; Source is a constant
	sta	$4300
	lda	#4		; Destination OAM
	sta	$4301
	ldx.l	#scroll1x		; Source pointer
	stx	$4302
	stz	$4304
	ldx	#272*2
	stx	$4305
	lda	#1		; Start it! DMA #0
	sta	$420b
	rts

reset_vram			; Clear VRAM
	stz	scroll1x
	stz	scroll1x+1
	lda	#%1001		; Source is a constant
	sta	$4300
	lda	#$18		; Destination VRAM
	sta	$4301
	ldx.l	#scroll1x		; Source pointer
	stx	$4302
	stz	$4304
	stz	$4305		; Size 64K
	stz	$4306
	lda	#1		; Start it! DMA #0
	sta	$420b
	rts

reset_cram			; Clear CRAM
	stz	scroll1x
	stz	scroll1x+1
	lda	#%1000		; Source is a constant
	sta	$4300
	lda	#$22		; Destination CRAM
	sta	$4301
	ldx.l	#scroll1x		; Source pointer
	stx	$4302
	stz	$4304
	ldx	#$200
	stx	$4305
	lda	#1		; Start it! DMA #0
	sta	$420b
	rts

ints_on
	lda	scrnfade		; enable screen
	and	#$7f
	sta	scrnfade
	sta	$2100
	lda	#$80		; enable VBL
	sta	$4200
	rts

ints_off
	lda	scrnfade		; disable screen
	ora	#$80
	sta	scrnfade
	sta	$2100
	stz	$4200		; disable VBL
	rts


********************************************************
music_init
	rep	#$30
	jsr	$88000	
	jsr	$88026	
	lda.l	#1
	bra	music_go

music_init2
	rep	#$30
	lda.l	#5
music_go
	jsr	$880d3	
	jsr	$880c4
	rep	#$30
	lda	#$7f00
	sta	$2142
	sep	#$20
	rts

********************************************************

scroller_init
	lda	#1		; mode 1
	sta	$2105
	lda	#1 		; set playfield 0 vram address
	sta	$2107
	lda	#$11
	sta	$210b		; set playfield 0 & 1 tile address
	lda	#$11		; enable playfield 0 & sprites
	sta	$212c
	stz	$212d		; disable all others
	lda	#3		; Sprite base address = $6000
	sta	$2101	
	lda	#$f
	sta	scrnfade

	lda	#scroller_pallette>>16
	ldx.l	#scroller_pallette&$ffff
	jsr	change_pal

	lda	#$80		; Blit empty char on
	sta	$2115
	ldx	#$1000
	stx	$2116
	ldx.l	#0
	stx	scroll1x
	lda	#%1001
	sta	$4300
	lda	#$18
	sta	$4301
	ldx.l	#scroll1x
	stx	$4302
	stz	$4304
	ldx.l	#$20		; size
	stx	$4305
	lda	#1
	sta	$420b

	lda	#$80		; Init screen 1
	sta	$2115
	ldx	#$180
	stx	$2116
	rep	#$20
	ldx.l	#1		; Character 1
	ldy.l	#7		; 7 lines high
.0	phx
	lda.l	#32		; 32 chars wide
.1	stx	$2118
	inx
	inx
	inx
	inx
	inx
	inx
	inx
	dec
	bne	.1
	plx
	inx
	dey			; Next line
	bne	.0
	sep	#$20

	lda	#$80		; Init screen 2
	sta	$2115
	ldx	#$580
	stx	$2116
	rep	#$20
	ldx.l	#$e1		; Character 33
	ldy.l	#7		; 7 lines high
.2	phx
	lda.l	#32		; 32 chars wide
.3	stx	$2118
	inx
	inx
	inx
	inx
	inx
	inx
	inx
	dec
	bne	.3
	plx
	inx
	dey			; Next line
	bne	.2
	sep	#$20

	ldx.l	#0
	stx	scroll1x
	stx	scroll1y
	stx	horpos
	stx	mespos
	ldx.l	#$2890		; Address of char $119 (8th char)
	stx	chrptr
	lda	#1
	sta	char_size
	stz	dma0f
	rts

scroller_hdma_init
	stz	hdma_ptr
	stz	hdma_ptr+1
	lda	#$42		; Init HDMA 7
	sta	$4370
	lda	#$d
	sta	$4371
	ldx	#scrl_copper&$ffff
	stx	$4372
	lda	#scrl_copper>>16
	sta	$4374
	stz	$4377 
	lda	#$80		; Enable HDMA 7
	sta	hdma_on
	rts

scrl_copper
	dcb	12*8-1
	dcw	.none
	dcb	128+64
	dcw	scrl_table
.none	dcw	0

********************************************************
stars_init
	stz	$4300		; DMA #0 to transfer palette
	lda	#$80
	sta	$2121		; set pallete pointer to sprites
	lda	#$22
	sta	$4301
	ldx.l	#star_pal&$ffff
	stx	$4302		; source address (bottom 16 bits)
	lda	#star_pal>>16
	sta	$4304		; source bank number (top 8 bits)
	ldx.l	#$60
	stx	$4305		; transfer size
	lda	#1
	sta	$420b		; and start the DMA channel

	lda	#1		; DMA #1 to transfer sprites
	sta	$4300
	lda	#$80
	sta	$2115
	ldx	#$6000		; To VRAM $6000
	stx	$2116
	lda	#$18
	sta	$4301
	ldx.l	#star_char&$ffff
	stx	$4302		; source address (bottom 16 bits)
	lda	#star_char>>16
	sta	$4304		; source bank number (top 8 bits)
	ldx.l	#$20
	stx	$4305		; transfer size
	lda	#1
	sta	$420b		; and start the DMA channel
	jsr	make_stars
	rts

make_stars ; Set up sprite table
	rep	#$20
	ldx.l	#spr_table	; Make table of sprite positions
	ldy.l	#32
	lda.l	#0		; OBJ 0..31 = Blank
.1	sta	0,x
	sta	2,x
	inx
	inx
	inx
	inx
	dey
	bne	.1
	lda	star_dir		; Get star direction
	ror
	ror
	ror
	and.l	#$c000
	pha	
	ldy.l	#0		; OBJ 32..127 = Stars
.2	lda	star_random,y
	sta	0,x
	lda	1,s
	sta	2,x
	inx
	inx
	inx
	inx
	iny
	iny
	cpy.l	#32*2
	bne	.2
	pla
	ora.l	#$200
	pha
.3	lda	star_random,y
	sta	0,x
	lda	1,s
	sta	2,x
	inx
	inx
	inx
	inx
	iny
	iny
	cpy.l	#64*2
	bne	.3
	pla
	and.l	#$fdff
	ora.l	#$400
	pha
.4	lda	star_random,y
	sta	0,x
	lda	1,s
	sta	2,x
	inx
	inx
	inx
	inx
	iny
	iny
	cpy.l	#96*2
	bne	.4
	pla
	lda.l	#%0101010101010101	; OBJ 0..31 are off screen
	ldy.l	#4
.5	sta	0,x
	inx
	inx
	dey
	bne	.5
	lda.l	#0		; OBJ 32..127 are off screen
	ldy.l	#12
.6	sta	0,x
	inx
	inx
	dey
	bne	.6
	sep	#$20
	rts

star_pal
	dcw	0,2<<10+2<<5+2,4<<10+4<<5+4,6<<10+6<<5+6
	dcw	8<<10+8<<5+8,10<<10+10<<5+10,12<<10+12<<5+12,14<<10+14<<5+14
	dcw	16<<10+16<<5+16,18<<10+18<<5+18,20<<10+20<<5+20,22<<10+22<<5+22
	dcw	24<<10+24<<5+24,26<<10+26<<5+26,28<<10+28<<5+28,30<<10+30<<5+30

	dcw	0,0,0,0
	dcw	0,2<<10+2<<5+2,4<<10+4<<5+4,6<<10+6<<5+6
	dcw	8<<10+8<<5+8,10<<10+10<<5+10,12<<10+12<<5+12,14<<10+14<<5+14
	dcw	16<<10+16<<5+16,18<<10+18<<5+18,20<<10+20<<5+20,22<<10+22<<5+22

	dcw	0,0,0,0
	dcw	0,0,0,0
	dcw	0,2<<10+2<<5+2,4<<10+4<<5+4,6<<10+6<<5+6
	dcw	8<<10+8<<5+8,10<<10+10<<5+10,12<<10+12<<5+12,14<<10+14<<5+14

star_char
	dcb	%00000001,%00000001 		
	dcb	%00000010,%00000000 		
	dcb	%00000100,%00000100 		
	dcb	%00001000,%00000000 		
	dcb	%00010000,%00010000 		
	dcb	%00100000,%00000000 		
	dcb	%01000000,%01000000 		
	dcb	%10000000,%00000000 		

	dcb	%00000001,%00000001 		
	dcb	%00000010,%00000010 		
	dcb	%00000000,%00000100 		
	dcb	%00000000,%00001000 		
	dcb	%00010000,%00000000 		
	dcb	%00100000,%00000000 		
	dcb	%00000000,%00000000 		
	dcb	%00000000,%00000000 		

star_random
	dcb	124,155,14,84,181,25,215,20,255,82,222,227,254,8,13,53
	dcb	23,251,158,80,17,91,227,236,79,198,60,63,135,136,245,179
	dcb	105,206,103,63,152,37,148,29,243,93,36,97,3,170,113,162
	dcb	15,169,14,187,47,154,245,90,98,244,73,218,117,39,79,168
	dcb	67,44,34,39,162,66,40,215,7,236,97,56,161,23,16,163
	dcb	140,247,76,22,88,1,149,182,240,30,87,114,186,230,16,22
	dcb	111,151,131,194,255,6,27,123,130,198,117,92,21,63,188,158
	dcb	28,117,53,117,61,184,63,119,38,120,156,22,216,2,191,97
	dcb	32,202,124,0,100,167,94,61,249,14,109,125,170,45,50,121
	dcb	21,140,78,39,28,127,219,15,126,149,124,151,97,211,207,108
	dcb	81,94,171,16,21,244,80,79,77,67,128,8,181,7,28,147
	dcb	154,130,204,182,188,181,190,237,192,98,131,127,239,206,160,148

********************************************************
dots_init
	lda	#2		; Set base address to $4000
	sta	$2101
	stz	mode7_type	; Reset logo movements
	lda	#200		; Reset time delay
	sta	mode7_time
	ldx.l	#100
	stx	scroll1y
		
	lda	#1		; DMA #0 to transfer sprites
	sta	$4300
	lda	#$80
	sta	$2115
	ldx	#$4000		; To VRAM $4000
	stx	$2116
	lda	#$18
	sta	$4301
	ldx.l	#dot_char&$ffff
	stx	$4302		; source address (bottom 16 bits)
	lda	#dot_char>>16
	sta	$4304		; source bank number (top 8 bits)
	ldx.l	#$20
	stx	$4305		; transfer size
	lda	#1
	sta	$420b		; and start the DMA channel
	jsr	make_dots
	rts

make_dots ; Setup sprite table
	rep	#$20
	ldx.l	#spr_table	; Make table of sprite positions
	ldy.l	#64
	lda.l	#0		; OBJ 0..63 = Blank
.1	sta	0,x
	sta	2,x
	inx
	inx
	inx
	inx
	dey
	bne	.1
	ldy.l	#0		; OBJ 64..127 = Stars
.2	lda	dot_random,y
	sta	0,x
	lda.l	#%0000111000000000
	sta	2,x
	inx
	inx
	inx
	inx
	iny
	iny
	cpy.l	#64*2
	bne	.2
	lda.l	#%0101010101010101	; OBJ 0..63 are off screen
	ldy.l	#8
.3	sta	0,x
	inx
	inx
	dey
	bne	.3
	lda.l	#0		; OBJ 64..127 are off screen
	ldy.l	#8
.4	sta	0,x
	inx
	inx
	dey
	bne	.4
	sep	#$20
	rts

dot_char
	dcb	%10000000,%10000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000

	dcb	%10000000,%10000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000
	dcb	%00000000,%00000000

dot_random
	dcb	121,23,78,80,14,46,141,48,214,99,186,20,250,98,231,50
	dcb	121,48,90,6,255,37,83,73,71,54,155,17,5,92,64,35
	dcb	9,1,152,83,36,6,93,42,253,25,147,79,228,19,129,0
	dcb	76,87,222,2,117,75,21,92,123,61,48,2,206,46,216,30
	dcb	196,45,108,94,198,75,39,66,95,83,219,30,17,38,170,79
	dcb	195,16,211,45,56,23,115,29,205,44,206,72,123,28,139,81
	dcb	220,12,238,19,166,82,247,93,225,6,253,24,209,80,36,77
	dcb	82,83,203,73,23,37,198,30,30,3,12,87,57,64,42,26

********************************************************

mode7_init1 ; Walker specific stuff
	jsr	mode7_common1	
	ldx.l	#9*$80
	jsr	mode7_common2	
	ldx.l	#bounce_data
	stx	bounce_ptr
	ldx.l	#matrix1&$ffff
	stx	message
	lda	#matrix1>>16
	sta	message+2
	ldx.l	#matrix1_end-matrix1
	stx	matrix_size
	lda	#$a0		; Y centre
	sta	$2120
	stz	$2120
	rts

mode7_init2 ; Waver specific stuff
	jsr	mode7_common1	
	ldx.l	#14*$80
	jsr	mode7_common2

	lda	#$80		; Clear 1st character
	sta	$2115
	stz	$2116
	stz	$2117
	lda	#$40
.clear	stz	$2119
	dec
	bne	.clear

	stz	$2115		; Change first tile to $1f
	ldx.l	#$80*14
	stx	$2116
	lda	#$1f
	sta	$2118

	stz	$212c		; Set main screen
	lda	#$11		; Set sub screen
	sta	$212d
	lda	#2
	sta	$2130
	lda	#$20
	sta	$2131

	lda	#200		; Matrix D = .200
	sta	$211e
	stz	$211e
	lda	#104		; Y centre = 104
	sta	$2120
	stz	$2120

	ldx.l	#100		; Y position
	stx	scroll1y

	ldx.l	#0 		; Reset sine pointer
	stx	sine_ptr
	lda	#111		; First line = 112,0,1
	sta	copper,x
	inx
	stz	copper,x
	inx
	lda	#1
	sta	copper,x
	inx
	ldy.l	#80		; 80 lines high
.1	sta	copper,x
	inx
	inx
	inx
	dey
	bne	.1
	stz	copper,x	 	; End marker
	jsr	init_hdma
	rts

mode7_init3 ; Spinner specific stuff
	jsr	mode7_common1	
	lda	#$11		; Enable sprites as well
	sta	$212c
	lda	#2
	sta	$2101
	lda	#$80		; X centre = $80
	sta	$211f
	stz	$211f
	lda	#$70		; Y centre = $78
	sta	$2120
	stz	$2120
	ldx.l	#matrix2&$ffff
	stx	message
	lda	#matrix2>>16
	sta	message+2
	ldx.l	#matrix2_end-matrix2
	stx	matrix_size

	jsr	make_table7	; Make sprite table
	ldx.l	#$2200		; DMA #0 to Palette across
	stx	$4300
	ldx.l	#pink_pal&$ffff
	stx	$4302		; source address (bottom 16 bits)
	lda	#pink_pal>>16
	sta	$4304		; source bank number (top 8 bits)
	ldx.l	#$200
	stx	$4305		; transfer size
	lda	#0
	sta	$2121		; set pallete pointer to zero
	lda	#1		; DMA #1 to transfer sprites
	sta	$4310
	lda	#$80
	sta	$2115
	stz	$2116		; To VRAM $4000
	lda	#$40
	sta	$2117
	lda	#$18
	sta	$4311
	ldx.l	#spr_char7&$ffff
	stx	$4312		; source address (bottom 16 bits)
	lda	#spr_char7>>16
	sta	$4314		; source bank number (top 8 bits)
	ldx	#$4000
	stx	$4315		; transfer size
	lda	#3
	sta	$420b		; and start the DMA channels
	lda	#$80		; DMA to transfer graphics across
	sta	$2115
	ldx.l	#0
	stx	$2116
	stz	$4300
	lda	#$19
	sta	$4301
	ldx.l	#pink_char&$ffff	; Source
	stx	$4302
	lda	#pink_char>>16
	sta	$4304
	ldx	#$4000
	stx	$4305
	lda	#1
	sta	$420b		; Just do it

	ldx.l	#$0300		; Add screen data
	lda	#$00
	sta	$2115
	stx	$2116
	lda	#$00
.1	ldy.l	#8		; 8 Spaces
.2	stz	$2118
	dey
	bne	.2
	ldy.l	#16		; 16 Characters
.3	sta	$2118
	inc
	dey
	bne	.3
	ldy.l	#$68		; 8 + $60 Spaces
.4	stz	$2118
	dey
	bne	.4
	cmp	#0
	bne	.1
	rts

mode7_common1
	lda	#$f
	sta	scrnfade
	lda	#7		; Mode 7
	sta	$2105
	stz	$2106		; No Mosaic 
	lda	#1		; Set main screen		
	sta	$212c
	stz	$212d		; Set sub screen
	stz	$212e		; Set masking
	stz	$212f
	stz	$2133		; No EXTBG
	lda	#$c0		; No flipping/repetition
	sta	$211a
	ldx.l	#0
	stx	matrix_ptr
	rts

mode7_common2
	lda	#0		; Add screen data
	sta	$2115
	stx	$2116
.1	ldy.l	#$20
.2	sta	$2118
	inc
	dey
	bne	.2
	ldy.l	#$60
.3	stz	$2118
	dey
	bne	.3
	cmp	#0
	bne	.1

	stz	$4300		; DMA to transfer pallette across
	lda	#$22
	sta	$4301
	ldx.l	#mode7_pal&$ffff
	stx	$4302		; source address (bottom 16 bits)
	lda	#mode7_pal>>16
	sta	$4304		; source bank number (top 8 bits)
	ldx	#$200
	stx	$4305		; transfer size
	stz	$2121		; set pallete pointer to zero
	lda	#1
	sta	$420b		; and start the DMA channel

	lda	#$80		; DMA to transfer graphics across
	sta	$2115
	ldx.l	#0
	stx	$2116
	stz	$4300
	lda	#$19
	sta	$4301
	ldx.l	#mode7_chars&$ffff	; Source
	stx	$4302
	lda	#mode7_chars>>16
	sta	$4304
	ldx	#$4000
	stx	$4305
	lda	#1
	sta	$420b		; Just do it
	
	ldx.l	#0
	stz	scroll1x
	stz	scroll1y

	lda	#$01		; Matrix (1,0)
	stz	$211b		;        (0,1)	
	sta	$211b				
	stz	$211c
	stz	$211c
	stz	$211d
	stz	$211d				
	stz	$211e
	sta	$211e

	lda	#$80		; X centre = $80
	sta	$211f
	stz	$211f
	lda	#$70		; Y centre = $70
	sta	$2120
	stz	$2120
	rts

init_hdma
	lda	#3		; Init HDMA 6
	sta	$4360
	lda	#$21		; Hit the pallette register
	sta	$4361
	ldx	#colour_copper
	stx	$4362
	stz	$4364
	stz	$4367

	lda	#2		; Init HDMA 7
	sta	$4370
	lda	#$1b		; Hit the 'Matrix A' register
	sta	$4371
	ldx	#copper
	stx	$4372
	stz	$4374
	stz	$437

	lda	#$c0		; Enable HDMA 6 and 7
	sta	hdma_on
	rts

; Set up sprite table
make_table7
	ldx	#spr_table	; Make table of sprite positions
	ldy.l	#0		; OBJ 0..5 = Letters
	lda	#6*4
.1	pha
	lda	.letters,y
	sta	0,x
	iny
	inx
	pla
	dec
	bne	.1
	rep	#$20
	ldy.l	#122		; OBJ 6..127 = Char 0
.2	lda	#$2020
	sta	0,x
	lda.l	#0
	sta	2,x
	inx
	inx
	inx
	inx
	dey
	bne	.2
	lda.l	#%0101101010101010	; OBJ 0..5 are Big
	sta	0,x
	inx
	inx
	lda.l	#$5555		; OBJ 6..127 are Small
	ldy.l	#15
.3	sta	0,x
	inx
	inx
	dey
	bne	.3
	sep	#$20

	stz	$4300		; DMA #0 to transfer sprite table
	stz	$2102		; To OAM $000
	stz	$2103
	lda	#4
	sta	$4301
	ldx	#spr_table
	stx	$4302		; source address (bottom 16 bits)
	stz	$4304		; source bank number (top 8 bits)
	ldx.l	#272*2
	stx	$4305		; transfer size
	lda	#$01
	sta	$420b		; and start the DMA channel
	rts

.letters	; Table of x_pos, y_pos, char_lo, char_hi
	dcb	$48,the_endy,0,$3e	; T
	dcb	$59,the_endy,2,$3e	; H
	dcb	$6a,the_endy,4,$3e	; E
	dcb	$86,the_endy,4,$3e	; E
	dcb	$97,the_endy,6,$3e	; N 
	dcb	$a8,the_endy,8,$3e	; D

colour	equ	10

colour_copper
	dcb	100		; 100 lines of this data
	dcw	0,0

	dcb	128+20		; Now 20 lines of the following
	dcw	0,1<<colour
	dcw	0,2<<colour
	dcw	0,3<<colour
	dcw	0,4<<colour
	dcw	0,5<<colour
	dcw	0,6<<colour
	dcw	0,7<<colour
	dcw	0,8<<colour
	dcw	0,9<<colour
	dcw	0,10<<colour
	dcw	0,11<<colour
	dcw	0,12<<colour
	dcw	0,13<<colour
	dcw	0,14<<colour
	dcw	0,15<<colour
	dcw	0,16<<colour
	dcw	0,17<<colour
	dcw	0,18<<colour
	dcw	0,19<<colour
	dcw	0,20<<colour
	dcb	0

********************************************************

sprites_init
	lda	#$f
	sta	scrnfade
	lda	#7		; Mode 1
	sta	$2105
	stz	$2106		; No Mosaic 
	lda	#$11		; Set sprites on and screen
	sta	$212c
	stz	$212d		; Set sub screen
	stz	$212e		; Set masking
	stz	$212f
	stz	$2133		; Non interlace, 234 high
	lda	#$a2
	sta	$2101		; Set size & base address

	jsr	make_stable	; make sprite table

	stz	$4300		; DMA to transfer pallette
	lda	#$80
	sta	$2121		; set pallete pointer to sprites
	lda	#$22
	sta	$4301
	ldx.l	#sprites_pallette&$ffff
	stx	$4302		; source address (bottom 16 bits)
	lda	#sprites_pallette>>16
	sta	$4304		; source bank number (top 8 bits)
	ldx.l	#$20
	stx	$4305		; transfer size
	lda	#1
	sta	$420b		; and start the DMA channel

	lda	#1		; DMA to transfer sprites
	sta	$4310
	lda	#$80
	sta	$2115
	stz	$2116		; To VRAM $4000
	lda	#$40
	sta	$2117
	lda	#$18
	sta	$4311
	ldx.l	#spr_char&$ffff
	stx	$4312		; source address (bottom 16 bits)
	lda	#spr_char>>16
	sta	$4314		; source bank number (top 8 bits)
	ldx	#$4000
	stx	$4315		; transfer size
	lda	#2
	sta	$420b		; and start the DMA channel
	
	stz	$2121		; Set pallette
	stz	$2122
	stz	$2122
	lda	#$ff
	sta	$2122
	lda	#$7f
	sta	$2122

	lda	#$80		; Character set to $0000 - $4000
	sta	$2115
	stz	$2116
	stz	$2117
	ldx.l	#64
	txy
.0	stz	$2119
	dex
	bne	.0
	lda	#1
.1	sta	$2119
	dey
	bne	.1

	stz	$2115		; Add screen data
	stz	$2116
	stz	$2117
	ldx.l	#16		; 16 * 8 = 128 chars down
.2	lda	#4
.3	pha
	ldy.l	#16		; 16 * 8 = 128 chars across
	lda	#1
.4	sta	$2118
	sta	$2118
	sta	$2118
	sta	$2118
	stz	$2118
	stz	$2118
	stz	$2118
	stz	$2118
	dey
	bne	.4
	pla
	dec
	bne	.3
	lda	#4
.5	pha
	ldy.l	#16		; 16 * 8 = 128 chars across
	lda	#1
.6	stz	$2118
	stz	$2118
	stz	$2118
	stz	$2118
	sta	$2118
	sta	$2118
	sta	$2118
	sta	$2118
	dey
	bne	.6
	pla
	dec
	bne	.5
	dex
	bne	.2

	ldx.l	#0		; Reset pointers
	stx	spr_ptrx
	stx	spr_ptry
	stx	chess_x
	stx	chess_y
	stx	chess_z
	rts

; Set up sprite table
make_stable
	rep	#$20		; Make table of sprite positions
	ldx	#spr_table
	ldy.l	#0		; OBJ 0..6 = Letters, at (0,0)
	lda.l	#7
.1	pha
	stz	0,x
	stz	1,x
	lda	.letters,y
	sta	2,x
	iny
	iny
	inx
	inx
	inx
	inx
	pla
	dec
	bne	.1
	ldy.l	#121		; OBJ 7..127 = Char $188 (Blank)
.2	lda	#$2020
	sta	0,x
	lda	#$188
	sta	2,x
	inx
	inx
	inx
	inx
	dey
	bne	.2
	lda.l	#%0110101010101010	; OBJ 0..6 are Big
	sta	0,x
	inx
	inx
	lda.l	#$5555		; OBJ 7..127 are Small
	ldy.l	#15
.3	sta	0,x
	inx
	inx
	dey
	bne	.3
	sep	#$20
	rts

.letters	dcw	$3000,$3008,$3080,$3088,$3100,$3108,$3180

********************************************************

rings_init
	lda	#$f		; Brightness
	sta	scrnfade
	lda	#$00		; Mode 0
	sta	$2105
	stz	$2106		; No Mosaic 
	lda	#$13		; Screen at $1000 & size 4
	sta	$2107		; BG 1
	sta	$2108		; BG 2
	sta	$2109		; BG 3
	sta	$210a		; BG 4
	stz	$210b		; BG 1 & 2 name base
	stz	$210c		; BG 3 & 4 name base
	stz	$210d		; BG 1 scroll x
	stz	$210d
	stz	$210e		; BG 1 scroll y
	stz	$210e
	lda	#$11		; Enable bg #1 & sprites as main
	sta	$212c
	lda	#2		; Enable bg #2 as sub screen
	sta	$212d
	stz	$212e		; Set masking
	stz	$212f
	stz	$2133		; Non interlace, 234 high
	lda	#2		; Enable Colour Add/Sub
	sta	$2130
	lda	#1		; Sub data from bg1
	sta	$2131
	lda	#$e0		; Fixed Colour = Black
	sta	$2132
	lda	#$41		; Set sprite size & base address
	sta	$2101

	lda	#0		; Col 0 = $0000
	sta	$2121
	stz	$2122
	stz	$2122
	lda	#1		; Col 1 = $0000
	sta	$2121
	stz	$2122
	stz	$2122
	lda	#3		; Col 3 = $021f
	sta	$2121
	lda	#$1f
	sta	$2122
	lda	#$02
	sta	$2122
	lda	#$20		; Col $20 = $0000
	sta	$2121
	stz	$2122
	stz	$2122
	lda	#$21		; Col $21 = $0000
	sta	$2121
	stz	$2122
	stz	$2122
	lda	#$23		; Col $23 = $7e00
	sta	$2121
	lda	#$00
	sta	$2122
	lda	#$7e
	sta	$2122

	lda	#1		; DMA to transfer characters
	sta	$4310
	lda	#$80
	sta	$2115
	stz	$2116		; To VRAM $0000
	lda	#$0
	sta	$2117
	lda	#$18
	sta	$4311
	ldx.l	#ring_chars&$ffff
	stx	$4312		; source address (bottom 16 bits)
	lda	#ring_chars>>16
	sta	$4314		; source bank number (top 8 bits)
	ldx	#$4000
	stx	$4315		; transfer size
	lda	#2
	sta	$420b		; and start the DMA channel

	stz	$4300		; DMA #0 to transfer sprite palette
	lda	#$80
	sta	$2121		; set pallete pointer to sprites
	lda	#$22
	sta	$4301
	ldx.l	#rspr_pal&$ffff
	stx	$4302		; source address (bottom 16 bits)
	lda	#rspr_pal>>16
	sta	$4304		; source bank number (top 8 bits)
	ldx.l	#$20
	stx	$4305		; transfer size
	lda	#$01
	sta	$420b		; and start the DMA channel

	lda	#1		; DMA #1 to transfer sprites
	sta	$4310
	lda	#$80
	sta	$2115
	stz	$2116		; To VRAM $2000
	lda	#$20
	sta	$2117
	lda	#$18
	sta	$4311
	ldx.l	#rspr_char&$ffff
	stx	$4312		; source address (bottom 16 bits)
	lda	#rspr_char>>16
	sta	$4314		; source bank number (top 8 bits)
	ldx	#$4000
	stx	$4315		; transfer size
	lda	#$02
	sta	$420b		; and start the DMA channel

	ldx.l	#$ff00		; Reset sprite pointers
	stx	logo_x
	lda	#4
	sta	logo_y
	lda	#1
	sta	logo_dir
	lda	#3
	sta	logo_del
	jsr	make_rtable
	jsr	add_logo

	jsr	add_rings		; Put the rings on the 4 screens

	ldx.l	#0		; Init scroll reg.
	stx	scroll1x
	stx	scroll1y
	stx	scroll2x
	stx	scroll2y
	stx 	bg_ptrx
	stx	bg_ptry
	rts

add_rings	; Add rings to screen
	rep	#$20
	sep	#$10

; Screen 1, Top left
	ldx	#$80
	stx	$2115	
	lda	#$1000
	sta	$2116
	lda.l	#0
	ldy	#21		; 21 lines high
.11	pha
	ldx	#24		; 24 chars across
.12	sta	$2118
	inc
	dex
	bne	.12
	ldx	#8		; 8 chars across
	dec
	ora.l	#$4000		; Flip chars
.13	sta	$2118
	dec
	dex
	bne	.13
	pla			; Next line
	clc
	adc.l	#24
	dey
	bne	.11

	ldy	#11		; 11 lines high
	sec
	sbc.l	#24
	ora.l	#$8000		; Flip chars
.14	pha
	ldx	#24		; 24 chars across
.15	sta	$2118
	inc
	dex
	bne	.15
	ldx	#8		; 8 chars across
	dec
	ora.l	#$4000		; Flip chars
.16	sta	$2118
	dec
	dex
	bne	.16
	pla			; Next line
	sec
	sbc.l	#24
	dey
	bne	.14

; Screen 2, Top right
	ldx	#$80
	stx	$2115	
	lda	#$1400
	sta	$2116
	lda.l	#$400f
	ldy	#21		; 21 lines high
.21	pha
	ldx	#16		; 16 chars across
.22	sta	$2118
	dec
	dex
	bne	.22
	ldx	#16		; 16 spaces across
	lda.l	#21*24
.23	sta	$2118
	dex
	bne	.23
	pla			; Next line
	clc
	adc.l	#24
	dey
	bne	.21

	ldy	#11		; 11 lines high
	sec
	sbc.l	#24
	ora.l	#$8000		; Flip chars
.24	pha
	ldx	#16		; 16 chars across
.25	sta	$2118
	dec
	dex
	bne	.25
	ldx	#16		; 16 spaces across
	lda.l	#21*24
.26	sta	$2118
	dex
	bne	.26
	pla			; Next line
	sec
	sbc.l	#24
	dey
	bne	.24

; Screen 3, Bottom left
	ldx	#$80
	stx	$2115	
	lda	#$1800
	sta	$2116
	lda.l	#9*24+$8000
	ldy	#10		; 10 lines high
.31	pha
	ldx	#24		; 24 chars across
.32	sta	$2118
	inc
	dex
	bne	.32
	ldx	#8		; 8 chars across
	dec
	ora.l	#$4000		; Flip chars
.33	sta	$2118
	dec
	dex
	bne	.33
	pla			; Next line
	sec
	sbc.l	#24
	dey
	bne	.31

; Screen 4, Bottom right
	ldx	#$80
	stx	$2115	
	lda	#$1c00
	sta	$2116
	lda.l	#9*24+$c00f
	ldy	#10		; 10 lines high
.41	pha
	ldx	#16		; 16 chars across
.42	sta	$2118
	dec
	dex
	bne	.42
	ldx	#16		; 16 spaces across
	lda.l	#21*24
.43	sta	$2118
	dex
	bne	.43
	pla			; Next line
	sec
	sbc.l	#24
	dey
	bne	.41

; All done
	rep	#$10
	sep	#$20
	rts

; Takes logo_x & logo_y and puts it there!
add_logo
	ldx.l	#spr_table	; x -> sprite table
	lda	logo_y		; Add in y positions
	sta	$1,x
	sta	$5,x
	sta	$9,x
	sta	$d,x
	ldy	logo_x		; Add in x positions
	rep	#$30
	tya
	cmp	#$ff00
	bne	.ok1
	inc
.ok1	sep	#$20
	sta	$0,x
	xba
	bne	.set1
	lda	#%11111110
	and	$200,x
	bra	.done1
.set1	lda	#%00000001
	ora	$200,x
.done1	sta	$200,x
	rep	#$30
	tya
	clc
	adc.l	#$40
	tay
	cmp	#$ff00
	bne	.ok2
	inc
.ok2	sep	#$20
	sta	$4,x
	xba
	bne	.set2
	lda	#%11111011
	and	$200,x
	bra	.done2
.set2	lda	#%00000100
	ora	$200,x
.done2	sta	$200,x
	rep	#$30
	tya
	clc
	adc.l	#$40
	tay
	cmp	#$ff00
	bne	.ok3
	inc
.ok3	sep	#$20
	sta	$8,x
	xba
	bne	.set3
	lda	#%11101111
	and	$200,x
	bra	.done3
.set3	lda	#%00010000
	ora	$200,x
.done3	sta	$200,x
	rep	#$30
	tya
	clc
	adc.l	#$40
	cmp	#$ff00
	bne	.ok4
	inc
.ok4	sep	#$20
	sta	$c,x
	xba
	bne	.set4
	lda	#%10111111
	and	$200,x
	bra	.done4
.set4	lda	#%01000000
	ora	$200,x
.done4	sta	$200,x
	rts

; Set up sprite table
make_rtable
	rep	#$20		; Make table of sprite positions
	ldx	#spr_table
	ldy.l	#0		; OBJ 0..3 = Logo (at 0,0)
	lda.l	#4
.1	pha
	stz	0,x
	stz	1,x
	lda	.letters,y
	sta	2,x
	iny
	iny
	inx
	inx
	inx
	inx
	pla
	dec
	bne	.1
	ldy.l	#124		; OBJ 4..127 = Char $0
.2	lda	#$2020
	sta	0,x
	lda.l	#0
	sta	2,x
	inx
	inx
	inx
	inx
	dey
	bne	.2
	lda.l	#%0101010110101010	; OBJ 0..3 are Big
	sta	0,x
	inx
	inx
	lda.l	#$5555		; OBJ 4..127 are Small
	ldy.l	#15
.3	sta	0,x
	inx
	inx
	dey
	bne	.3
	sep	#$20
	rts

.letters	dcw	$3000,$3008,$3080,$3088

********************************************************
; Init bars
init_bars1
	lda	#$11		; mode 1
	sta	$2105
	lda	#$10		; set playfield 1 vram address
	sta	$2107
	lda	#$20 		; set playfield 2 vram address
	sta	$2108
	lda	#$30
	sta	$210b		; set playfield 1 & 2 tile address
	lda	#3		; enable playfield 1 and 2
	sta	$212c
	stz	$212d		; disable all others

	lda	#bar_pal1>>16
	ldx.l	#bar_pal1&$ffff
	jsr	change_pal
	stz	$2116		; To VRAM $3000
	lda	#$30
	sta	$2117
	lda	#1
	sta	$4310
	lda	#$18
	sta	$4311
	ldx.l	#bar_char&$ffff
	stx	$4312
	lda	#bar_char>>16
	sta	$4314
	ldx	#$2000
	stx	$4315
	lda	#2
	sta	$420b		; and start the DMA channels

	lda	#$80		; Put characters on screen
	sta	$2115
	stz	$2116		; To VRAM $2000
	lda	#$20
	sta	$2117
	lda	#0
	ldy.l	#32*32
.1	sta	$2118
	stz	$2119
	inc
	dey
	bne	.1

	lda	#$10		; DMA pallette across
	sta	$2121
	stz	$4300
	lda	#$22
	sta	$4301
	ldx.l	#text_pal&$ffff
	stx	$4302
	lda	#text_pal>>16
	sta	$4304
	ldx.l	#$20
	stx	$4305
	lda	#1
	sta	$420b
	lda	#$80		; DMA to transfer character set
	sta	$2115
	stz	$2116		; To VRAM $0000
	stz	$2117
	lda	#1
	sta	$4300
	lda	#$18
	sta	$4301
	ldx.l	#text_char&$ffff
	stx	$4302
	lda	#text_char>>16
	sta	$4304
	ldx	#$2000
	stx	$4305
	lda	#1
	sta	$420b		; and start the DMA channels

	stz	bar_pos		; Set up first table
	stz	bar_pos1
	stz	bar_pos1+1
	stz	bar_pos2
	stz	bar_pos2+1
	ldx.l	#0
	stx	bar_type
	jsr	bars

	stz	text_del		; Reset delay counter
	stz	scroll1y		; Reset scroll pos
	stz	scroll1y+1
	ldx.l	#text11
	jsr	print
	ldx.l	#text12
	jsr	print
	ldx.l	#text13
	jsr	print

	lda	#$40		; Init HDMA 7
	sta	$4370
	lda	#$10
	sta	$4371
	ldx	#bar_copper&$ffff
	stx	$4372
	lda	#bar_copper>>16
	sta	$4374
	stz	$4377 
	lda	#$80		; Enable HDMA 7
	sta	hdma_on
	rts

init_bars2
	jsr	clear_screen
	lda	#bar_pal2>>16
	ldx.l	#bar_pal2&$ffff
	jsr	change_pal
	stz	bar_pos		; Set up first table
	stz	bar_pos1
	stz	bar_pos1+1
	stz	bar_pos2
	stz	bar_pos2+1
	ldx.l	#2
	stx	bar_type
	jsr	bars

	stz	text_del		; Reset delay counter
	stz	scroll1y		; Reset scroll pos
	stz	scroll1y+1
	ldx.l	#text21
	jsr	print
	ldx.l	#text22
	jsr	print
	ldx.l	#text23
	jsr	print
	ldx.l	#text24
	jsr	print
	ldx.l	#text25
	jsr	print
	ldx.l	#text26
	jsr	print
	ldx.l	#text27
	jsr	print
	ldx.l	#text28
	jsr	print
	rts

init_bars3
	jsr	clear_screen
	lda	#bar_pal3>>16
	ldx.l	#bar_pal3&$ffff
	jsr	change_pal
	stz	bar_pos		; Set up first table
	stz	bar_pos1
	stz	bar_pos1+1
	stz	bar_pos2
	stz	bar_pos2+1
	ldx.l	#4
	stx	bar_type
	jsr	bars

	stz	text_del		; Reset delay counter
	stz	scroll1y		; Reset scroll pos
	stz	scroll1y+1
	ldx.l	#text31
	jsr	print
	ldx.l	#text32
	jsr	print
	ldx.l	#text33
	jsr	print
	ldx.l	#text34
	jsr	print
	ldx.l	#text35
	jsr	print
	ldx.l	#text36
	jsr	print
	rts

init_bars4
	jsr	clear_screen
	lda	#bar_pal4>>16
	ldx.l	#bar_pal4&$ffff
	jsr	change_pal
	stz	bar_pos		; Set up first table
	stz	bar_pos1
	stz	bar_pos1+1
	stz	bar_pos2
	stz	bar_pos2+1
	ldx.l	#6
	stx	bar_type
	jsr	bars

	stz	text_del		; Reset delay counter
	stz	scroll1y		; Reset scroll pos
	stz	scroll1y+1
	ldx.l	#text41
	jsr	print
	ldx.l	#text42
	jsr	print
	ldx.l	#text43
	jsr	print
	ldx.l	#text44
	jsr	print
	ldx.l	#text45
	jsr	print
	ldx.l	#text46
	jsr	print
	ldx.l	#text47
	jsr	print
	rts

clear_screen ; Clear the screen for the text
	lda	#$80
	sta	$2115
	ldx.l	#$1000
	stx	$2116
	ldx.l	#$400
.1	stz	$2118
	stz	$2119
	dex
	bne	.1
	rts

change_pal ; (a<<16+x) -> pallette
	stz	$2121		; DMA #0 for Pallette
	stz	$4300
	stx	$4302
	sta	$4304
	lda	#$22
	sta	$4301
	ldx.l	#$20
	stx	$4305
	lda	#1
	sta	$420b
	rts

print ; x -> text
	lda	#0
	xba
	lda	1,x	; Get Y position
	rep	#$20	; Multiply by 32
	clc
	asl
	asl
	asl
	asl
	asl
	adc.l	#$1000	; Add in screen start position
	sep	#$20
	adc	0,x	; Add x position
	rep	#$20
	tay
	lda	#%0000010000000000
	sep	#$20
	lda	#$80	; Going to VRAM
	sta	$2115
	sty	$2116
	inx
	inx
.1	lda	0,x
	beq	.2
	sec
	sbc	#32
	tay
	and	#7
	asl
	pha
	tya
	and	#$f8
	clc
	asl
	asl
	adc	1,s		
	rep	#$20
	sta	$2118
	sep	#$20
	pla
	inx
	bra	.1
.2	rts

bar_copper
	dcb	128+116
	dcw	bar_tab+2
	dcb	128+117
	dcw	bar_tab+118
	dcb	0

; Y position = 14 for next screen
text11	dcb	4,16,'CREDITS',0
text12	dcb	2,20,'ALL CODE BY',0
text13	dcb	0,21,'ANDY THE ARFLING',0

text21	dcb	4,16,'CREDITS',0
text22	dcb	4,18,'LOGOS BY',0
text23	dcb	4,19,'MELTDOWN',0
text24	dcb	6,20,'AND',0
text25	dcb	0,21,'ANDY THE ARFLING',0
text26	dcb	2,23,'FONT  RIPPED',0
text27	dcb	1,24,'FROM THE AMIGA',0
text28	dcb	4,25,'THANKS',0

text31	dcb	4,16,'CREDITS',0
text32	dcb	3,18,'MUSIC FROM',0
text33	dcb	1,19,'NIGEL MANSELLS',0
text34	dcb	3,20,'GRAND PRIX',0
text35	dcb	3,22,'RIPPED BY',0
text36	dcb	0,23,'ANDY THE ARFLING',0

text41	dcb	4,16,'CREDITS',0
text42	dcb	1,18,'ASSEMBLED WITH',0
text43	dcb	2,19,'ORGASM V2$4',0
text44	dcb	7,20,'BY',0
text45	dcb	0,21,'ANDY THE ARFLING',0
text46	dcb	1,23,'THANK YOU FOR',0
text47	dcb	4,24,'WATCHING',0

********************************************************

message0	bin	\source\scroller\message0.bin
message1	bin	\source\scroller\message1.bin
message2	bin	\source\scroller\message2.bin
message3	bin	\source\scroller\message3.bin

bounce_data
	dcb	0,3,7,10,14,16,19,21,24,25,27,28,30,30,31,31
	dcb	32,31,31,30,30,28,27,25,24,21,19,16,14,10,7,3
	dcb	255

bar_sine	bin	\source\bars\sine.dat
bar_sine_end

scroller_pallette
	bin	\source\scroller\grafix\divinchi.pal

mode7_pal	bin	\source\picture\snes\nesquik7.pal

ssinex	bin	\source\sprites\sinex.dat
ssinex_end bin	\source\sprites\sinex.dat

ssiney	bin	\source\sprites\siney.dat
ssiney_end bin	\source\sprites\siney.dat

sinex	bin	\source\rings\sinex.dat
sinex_end	bin	\source\rings\sinex.dat

siney	bin	\source\rings\siney.dat
siney_end	bin	\source\rings\siney.dat

sprites_pallette
	bin	\source\sprites\sprites.pal

wsine	bin	\source\mode7\wavelogo\sine.dat
wsine_end	bin	\source\mode7\wavelogo\sine.dat
	
	pad
pink_pal	bin	\source\picture\snes\pinknes7.pal
pink_char	bin	\source\picture\snes\pinknes7.dat

spr_char7	bin	\source\the_end\the_end.dat

ring_chars bin	\source\rings\rings2.dat

	pad

mode7_chars
	bin	\source\picture\snes\nesquik7.dat
picend

matrix1	bin	\source\mode7\walklogo\matrix.dat
matrix1_end

	pad

scroller_font
	dsb	$700			; Space gfx
	bin	\source\scroller\grafix\divinch1.dat	; Character set
	pad
	bin	\source\scroller\grafix\divinch2.dat	; Rest of char set
	
	pad
spr_char
	bin	\source\sprites\sprites.dat

rspr_pal	bin	\source\rings\pinknes.pal
rspr_char	bin	\source\rings\pinknes.dat

	pad

bar_pal1	dcw	0,1,2,3,4,5,6,7
	dcw	8,9,10,11,12,13,14,15
;bar_pal2	dcw	0,1<<10,2<<10,3<<10,4<<10,5<<10,6<<10,7<<10
;	dcw	8<<10,9<<10,10<<10,11<<10,12<<10,13<<10,14<<10,15<<10
bar_pal2	dcw	0,1<<10+1<<5+1,2<<10+2<<5+2,3<<10+3<<5+3,4<<10+4<<5+4,5<<10+5<<5+5,6<<10+6<<5+6,7<<10+7<<5+7
	dcw	8<<10+8<<5+8,9<<10+9<<5+9,10<<10+10<<5+10,11<<10+11<<5+11,12<<10+12<<5+12,13<<10+13<<5+13,14<<10+14<<5+14,15<<10+15<<5+15
bar_pal3	dcw	0<<10,1<<10+1,2<<10+2,3<<10+3,4<<10+4,5<<10+5,6<<10+6,7<<10+7
	dcw	8<<10+8,9<<10+9,10<<10+10,11<<10+11,12<<10+12,13<<10+13,14<<10+14,15<<10+15
bar_pal4	dcw	0,1<<5,2<<5,3<<5,4<<5,5<<5,6<<5,7<<5
	dcw	8<<5,9<<5,10<<5,11<<5,12<<5,13<<5,14<<5,15<<5
bar_char	bin	\source\bars\bars.dat

text_pal	bin	\source\bars\supreme.pal
text_char	bin	\source\bars\supreme.dat

matrix2	bin	\source\the_end\matrix2.dat
matrix2_end

scroll_sine
	bin	\source\scroller\sine.dat
scroll_sine_end
	bin	\source\scroller\sine.dat

scroll_bounce
	bin	\source\scroller\bounce.dat
scroll_bounce_end

chess_sinex
	bin	\source\sprites\chessx.dat
chess_sinex_end
chess_siney
	bin	\source\sprites\chessy.dat
chess_siney_end
chess_sinez
	bin	\source\sprites\chessz.dat
chess_sinez_end

	org	$88000
	bin	\source\music\nigel.mus
